#include "ChaosAndroid.h"
#include "ChaosAbort.h"
#include "AndroidPluginCommon.h"

jclass CreateJClass( char const* signature )
{
	JNIEnv* env = ChaosAndroidGetEnvironment();
	jobject activity = ThanatosAndroidGetActivityObject();
	
	jclass typeActivity = ( *env )->GetObjectClass( env, activity );
	jmethodID getClassLoader = ( *env )->GetMethodID( env, typeActivity, "getClassLoader", "()Ljava/lang/ClassLoader;" );
	if ( 0 == getClassLoader )
	{
		ChaosAbort(__FILE__,__LINE__);
	}
	( *env )->DeleteLocalRef( env, typeActivity );
	
	jobject classLoader = ( *env )->CallObjectMethod( env, activity, getClassLoader );
	if ( 0 == classLoader )
	{
		ChaosAbort(__FILE__,__LINE__);
	}
	
	jclass typeClassLoader = ( *env )->GetObjectClass( env, classLoader );
	jmethodID loadClass = ( *env )->GetMethodID( env, typeClassLoader, "loadClass", "(Ljava/lang/String;)Ljava/lang/Class;" );
	if ( 0 == loadClass )
	{
		ChaosAbort(__FILE__,__LINE__);
	}
	( *env )->DeleteLocalRef( env, typeClassLoader );
	
	jstring package = ( *env )->NewStringUTF( env, signature );
	if ( 0 == package )
	{
		ChaosAbort(__FILE__,__LINE__);
	}
	jclass typeTarget = ( *env )->CallObjectMethod( env, classLoader, loadClass, package );
	( *env )->DeleteLocalRef( env, package );
	( *env )->DeleteLocalRef( env, classLoader );
	
	jclass target = ( *env )->NewGlobalRef( env, typeTarget );
	if ( 0 == target )
	{
		ChaosAbort(__FILE__,__LINE__);
	}
	( *env )->DeleteLocalRef( env, typeTarget );
	
	return target;
}

void DestroyJClass( jclass target )
{
	JNIEnv* env = ChaosAndroidGetEnvironment();
	( *env )->DeleteGlobalRef( env, target );
}
