#include "ChaosAndroid.h"
#include "ThanatosAndroid.h"
#include "NemesisJavaScript.h"
#include "AndroidPluginCommon.h"
#include "LocalNotification.h"

jclass GetLocalNotification()
{
	return CreateJClass( "siliconstudio/localnotification/LocalNotification" );
}

void LocalNotificationInitialize()
{
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseUpdate, "LocalNotificationNotify", LocalNotificationNotify, 0 );
	NemesisJavaScriptAppendScript( "function LocalNotificationNotify(id,message,sec){Nemesis.PushCommand(Nemesis.UpdatePhase,\"LocalNotificationNotify\");Nemesis.PushInteger(id);Nemesis.PushString(message);Nemesis.PushInteger(sec);};" );
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseUpdate, "LocalNotificationCancel", LocalNotificationCancel, 0 );
	NemesisJavaScriptAppendScript( "function LocalNotificationCancel(id){Nemesis.PushCommand(Nemesis.UpdatePhase,\"LocalNotificationCancel\");Nemesis.PushInteger(id);};" );
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseUpdate, "LocalNotificationClear", LocalNotificationClear, 0 );
	NemesisJavaScriptAppendScript( "function LocalNotificationClear(){Nemesis.PushCommand(Nemesis.UpdatePhase,\"LocalNotificationClear\");};" );

	LocalNotificationClear( 0 );
}

void LocalNotificationFinalize()
{
}

void LocalNotificationNotify( void* args )
{
	( void )args;

	JNIEnv* env = ChaosAndroidGetEnvironment();
	jclass localNotification = GetLocalNotification();

	int32_t id = NemesisJavaScriptPopInteger( NemesisJavaScriptPhaseUpdate );
	char const* message = NemesisJavaScriptPopString( NemesisJavaScriptPhaseUpdate );
	int32_t sec = NemesisJavaScriptPopInteger( NemesisJavaScriptPhaseUpdate );
	
	jstring jMessage = ( *env )->NewStringUTF( env, message );
	
	jmethodID notify = ( *env )->GetStaticMethodID( env, localNotification, "Notify", "(Landroid/app/Activity;ILjava/lang/String;I)V" );
	( *env )->CallStaticVoidMethod( env, localNotification, notify, ThanatosAndroidGetActivityObject(), id, jMessage, sec );

	( *env )->DeleteLocalRef( env, jMessage );
	DestroyJClass( localNotification );
}

void LocalNotificationCancel( void* args )
{
	( void )args;

	JNIEnv* env = ChaosAndroidGetEnvironment();
	jclass localNotification = GetLocalNotification();

	int32_t id = NemesisJavaScriptPopInteger( NemesisJavaScriptPhaseUpdate );

	jmethodID cancel = ( *env )->GetStaticMethodID( env, localNotification, "Cancel", "(Landroid/app/Activity;I)V" );
	( *env )->CallStaticVoidMethod( env, localNotification, cancel, ThanatosAndroidGetActivityObject(), id );

	DestroyJClass( localNotification );
}

void LocalNotificationClear( void* args )
{
	( void )args;
	
	JNIEnv* env = ChaosAndroidGetEnvironment();
	jclass localNotification = GetLocalNotification();

	jmethodID notify = ( *env )->GetStaticMethodID( env, localNotification, "Clear", "(Landroid/app/Activity;)V" );
	( *env )->CallStaticVoidMethod( env, localNotification, notify, ThanatosAndroidGetActivityObject() );

	DestroyJClass( localNotification );
}
