#include "ChaosAndroid.h"
#include "ThanatosAndroid.h"
#include "NemesisJavaScript.h"
#include "AndroidPluginCommon.h"
#include "SmartBeatPlugin.h"

jclass GetSmartBeat()
{
	return CreateJClass( "siliconstudio/smartbeat/SmartBeat" );
}

void SmartBeatInitialize()
{
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseUpdate, "SmartBeatSetUserId", SmartBeatSetUserId, 0 );
	NemesisJavaScriptAppendScript( "function SmartBeatSetUserId(userId){Nemesis.PushCommand(Nemesis.UpdatePhase,\"SmartBeatSetUserId\");Nemesis.PushString(userId);};" );
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseUpdate, "SmartBeatLeaveBreadCrumbs", SmartBeatLeaveBreadCrumbs, 0 );
	NemesisJavaScriptAppendScript( "function SmartBeatLeaveBreadCrumbs(text){Nemesis.PushCommand(Nemesis.UpdatePhase,\"SmartBeatLeaveBreadCrumbs\");Nemesis.PushString(text);};" );
}

void SmartBeatFinalize()
{
}

void SmartBeatSetUserId( void* args )
{
	( void )args;

	JNIEnv* env = ChaosAndroidGetEnvironment();
	jclass smartBeat = GetSmartBeat();

	char const* userId = NemesisJavaScriptPopString( NemesisJavaScriptPhaseUpdate );
	jstring jUserId = ( *env )->NewStringUTF( env, userId );

	jmethodID setUserId = ( *env )->GetStaticMethodID( env, smartBeat, "SetUserId", "(Ljava/lang/String;)V" );
	( *env )->CallStaticVoidMethod( env, smartBeat, setUserId, jUserId );
	
	( *env )->DeleteLocalRef( env, jUserId );
	DestroyJClass( smartBeat );
}

void SmartBeatLeaveBreadCrumbs( void* args )
{
	( void )args;

	JNIEnv* env = ChaosAndroidGetEnvironment();
	jclass smartBeat = GetSmartBeat();

	char const* text = NemesisJavaScriptPopString( NemesisJavaScriptPhaseUpdate );
	jstring jText = ( *env )->NewStringUTF( env, text );

	jmethodID leaveBreadCrumbs = ( *env )->GetStaticMethodID( env, smartBeat, "LeaveBreadCrumbs", "(Ljava/lang/String;)V" );
	( *env )->CallStaticVoidMethod( env, smartBeat, leaveBreadCrumbs, jText );
	
	( *env )->DeleteLocalRef( env, jText );
	DestroyJClass( smartBeat );
}
