#include "ChaosAndroid.h"
#include "NemesisJavaScript.h"
#include "AndroidPluginCommon.h"
#include "StoreGameServices.h"

void StoreGameServicesInitialize()
{
	NemesisJavaScriptAppendScript( "var AchievementUnlockIds = [];" );
	NemesisJavaScriptAppendScript( "var StoreGameLoginFlag = false;" );
	NemesisJavaScriptAppendScript( "function StoreGameServices(){};StoreGameServices.ERROR_CODE={NONE:0,MISCONFIGURED:1,SIGN_IN_FAILED:2,LICENSE_FAILED:3,OTHER:4};" );
	NemesisJavaScriptAppendScript( "var StoreGameServicesSininErrorCode = StoreGameServices.ERROR_CODE.NONE;" );
	NemesisJavaScriptAppendScript( "function GetStoreGameServicesSigninErrorCode() { return StoreGameServicesSininErrorCode;}" );
	NemesisJavaScriptAppendScript( "function ClearStoreGameServicesSigninErrorCode() { StoreGameServicesSininErrorCode=StoreGameServices.ERROR_CODE.NONE;}" );
	NemesisJavaScriptAppendScript( "function IsStoreGameServicesLogin(){return true===StoreGameLoginFlag;};" );
	NemesisJavaScriptAppendScript( "function IsStoreGameServicesLoadedAchievement(){return null!=AchievementUnlockIds;};" );
	NemesisJavaScriptAppendScript( "function GetStoreGameServicesUnlockAchievementIds(){return AchievementUnlockIds;};" );
	
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseDraw, "StoreGameServicesSignIn", StoreGameServicesSignIn, 0 );
	NemesisJavaScriptAppendScript( "function StoreGameServicesSignIn(){Nemesis.PushCommand(Nemesis.DrawPhase,\"StoreGameServicesSignIn\");AchievementUnlockIds = null;};" );
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseDraw, "StoreGameServicesSignOut", StoreGameServicesSignOut, 0 );
	NemesisJavaScriptAppendScript( "function StoreGameServicesSignOut(){Nemesis.PushCommand(Nemesis.DrawPhase,\"StoreGameServicesSignOut\");};" );
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseDraw, "StoreGameServicesAchievementUnlock", StoreGameServicesAchievementUnlock, 0 );
	NemesisJavaScriptAppendScript( "function StoreGameServicesAchievementUnlock(achievementId){Nemesis.PushCommand(Nemesis.DrawPhase,\"StoreGameServicesAchievementUnlock\");Nemesis.PushString(achievementId);AchievementUnlockIds = null;};" );
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseDraw, "StoreGameServicesLeaderboardSubmitScore", StoreGameServicesLeaderboardSubmitScore, 0 );
	NemesisJavaScriptAppendScript( "function StoreGameServicesLeaderboardSubmitScore(leaderboardId,score){Nemesis.PushCommand(Nemesis.DrawPhase,\"StoreGameServicesLeaderboardSubmitScore\");Nemesis.PushString(leaderboardId);Nemesis.PushInteger(score);};" );
	NemesisJavaScriptAppendCommand( NemesisJavaScriptPhaseDraw, "StoreGameServicesShowAchievement", StoreGameServicesShowAchievement, 0 );
	NemesisJavaScriptAppendScript( "function StoreGameServicesShowAchievement(){Nemesis.PushCommand(Nemesis.DrawPhase,\"StoreGameServicesShowAchievement\");};" );
}

void StoreGameServicesFinalize()
{
	// nop
}

void StoreGameServicesStartCallback()
{
	// nop
}

void StoreGameServicesStopCallback()
{
	// nop
}

void StoreGameServicesLoginCallback()
{
	NemesisJavaScriptAppendScript( "var StoreGameLoginFlag = true;" );
}

void StoreGameServicesLogoutCallback()
{
	NemesisJavaScriptAppendScript( "var StoreGameLoginFlag = false;" );
	NemesisJavaScriptAppendScript( "AchievementUnlockIds = [];" );
}

void StoreGameServicesSignIn( void* args )
{
	( void )args;

	NemesisJavaScriptAppendScript( "var StoreGameServicesSininErrorCode = StoreGameServices.ERROR_CODE.NONE;" );
	
	JNIEnv* env = ChaosAndroidGetEnvironment();
	jobject activity = ThanatosAndroidGetActivityObject();	
	jclass typeActivity = ( *env )->GetObjectClass( env, activity );
	
	jmethodID signIn = ( *env )->GetMethodID( env, typeActivity, "StoreGameSignIn", "()V" );
	( *env )->CallVoidMethod( env, activity, signIn );
	
	( *env )->DeleteLocalRef( env, typeActivity );
}

void StoreGameServicesSignOut( void* args )
{
	( void )args;

	NemesisJavaScriptAppendScript( "var StoreGameServicesSininErrorCode = StoreGameServices.ERROR_CODE.NONE;" );

	JNIEnv* env = ChaosAndroidGetEnvironment();
	jobject activity = ThanatosAndroidGetActivityObject();	
	jclass typeActivity = ( *env )->GetObjectClass( env, activity );
	
	jmethodID signOut = ( *env )->GetMethodID( env, typeActivity, "StoreGameSignOut", "()V" );
	( *env )->CallVoidMethod( env, activity, signOut );
	
	( *env )->DeleteLocalRef( env, typeActivity );
}

void StoreGameServicesAchievementUnlock( void* args )
{
	( void )args;

	JNIEnv* env = ChaosAndroidGetEnvironment();
	jobject activity = ThanatosAndroidGetActivityObject();	
	jclass typeActivity = ( *env )->GetObjectClass( env, activity );
		
	char const* achievementId = NemesisJavaScriptPopString( NemesisJavaScriptPhaseDraw );
	jstring jAchievementId = ( *env )->NewStringUTF( env, achievementId );
	
	jmethodID achievementUnlock = ( *env )->GetMethodID( env, typeActivity, "AchievementUnlock", "(Ljava/lang/String;)V" );
	( *env )->CallVoidMethod( env, activity, achievementUnlock, jAchievementId );
	
	( *env )->DeleteLocalRef( env, jAchievementId );
	( *env )->DeleteLocalRef( env, typeActivity );
}

void StoreGameServicesLeaderboardSubmitScore( void* args )
{
	( void )args;

	JNIEnv* env = ChaosAndroidGetEnvironment();
	jobject activity = ThanatosAndroidGetActivityObject();	
	jclass typeActivity = ( *env )->GetObjectClass( env, activity );
		
	char const* leaderboardId = NemesisJavaScriptPopString( NemesisJavaScriptPhaseDraw );
	jstring jLeaderboardId = ( *env )->NewStringUTF( env, leaderboardId );
	
	int32_t score = NemesisJavaScriptPopInteger( NemesisJavaScriptPhaseDraw );
	
	jmethodID leaderboardSubmitScore = ( *env )->GetMethodID( env, typeActivity, "LeaderboardSubmitScore", "(Ljava/lang/String;I)V" );
	( *env )->CallVoidMethod( env, activity, leaderboardSubmitScore, jLeaderboardId, score );
	
	( *env )->DeleteLocalRef( env, jLeaderboardId );
	( *env )->DeleteLocalRef( env, typeActivity );
}

void StoreGameServicesAchievementLoadCallback( jstring jAchievementIds )
{
	JNIEnv* env = ChaosAndroidGetEnvironment();
	
	const char* achievementIds = ( *env )->GetStringUTFChars( env, jAchievementIds, 0 );
	NemesisJavaScriptAppendScript( "var AchievementUnlockIds = %s;", achievementIds );
	( *env )->ReleaseStringUTFChars( env, jAchievementIds, achievementIds );
}

void StoreGameServicesShowAchievement( void* args )
{
	( void )args;
	
	JNIEnv* env = ChaosAndroidGetEnvironment();
	jobject activity = ThanatosAndroidGetActivityObject();	
	jclass typeActivity = ( *env )->GetObjectClass( env, activity );
	
	jmethodID showAchievement = ( *env )->GetMethodID( env, typeActivity, "ShowAchievement", "()V" );
	( *env )->CallVoidMethod( env, activity, showAchievement );
	
	( *env )->DeleteLocalRef( env, typeActivity );
}

void StoreGameServicesSigninErrorUpdate( int errorCode )
{
	NemesisJavaScriptAppendScript( "var StoreGameServicesSininErrorCode = %d;", errorCode );
}
